-- Tracks XP gained -- 
local sessionXP = {}
local context = UI.CreateContext("uicontext")
local container = UI.CreateFrame("Mask", "container", context)
local startingxpbox = UI.CreateFrame("Text", "currxpbox", container)
local gainedXPFrame = UI.CreateFrame("Text", "gainedxp", container)
local on = false 



function xpGained ()
if on == true 
then
local prevxp = Inspect.Experience()
local xp = sessionXP["startingxp"]
local currXP = prevxp.accumulated - xp
sessionXP["gainedxp"] = tostring(currXP)
gainedXPFrame:SetText("Gained XP: "..currXP)
print("Gained:")
print(currXP)
else
-- do nothing --
end
end


function showxpGained ()
local gained = tostring(sessionXP["gainedxp"])
print("XP Gained: "..gained)
end




function buildUI ()
startingxpbox:SetPoint("CENTERLEFT", container, "CENTERLEFT")
gainedXPFrame:SetPoint("CENTERRIGHT", container, "CENTERRIGHT")
startingxpbox:SetFontSize(12)

container:SetPoint("TOPCENTER", UIParent, "TOPCENTER")

container:SetHeight(50)
container:SetWidth(400)


print("XPTracker loaded!")
end 

function recordXP ()
local startingxp = Inspect.Experience()
if startingxp.accumulated == nil
	then
	print("You are level 60!")
	else
	sessionXP["startingxp"] = startingxp.accumulated
	

	local startingXP = sessionXP["startingxp"]
	startingxpbox:SetText("Starting XP:"..startingXP)
	gainedXPFrame:SetText("Gained XP: Go gain some!")
	on = true
	end
end

function stoprecord ()
on = false
sessionXP["gainedxp"] = 0
end

function update (hEvent, accumulated)
	if on == true
	then
	local currXP = sessionXP["startingxp"]
	XP = accumulated - currXP
	sessionXP["gainedxp"] = tostring(XP)
	local dXP = tostring(XP)
	gainedXPFrame:SetText("Gained XP: "..dXP)
	else
-- do nothing -- 
	end
end




table.insert(Command.Slash.Register("xpstart"), {recordXP, "XPTracker", "Starting recording XP"})
table.insert(Command.Slash.Register("xpstop"), {stoprecord, "XPTracker", "Stoppnig recoring xp"})
table.insert(Command.Slash.Register("xpshow"), {showxpGained, "XPTracker", "showing XP value"})



Command.Event.Attach(Event.Experience.Accumulated, update, "updating current XP in sessionXP table")
Command.Event.Attach(Event.Addon.Load.End, buildUI, "building the ui on addon load end")
